## org.freedesktop.ModemManager1.Modem.Messaging

org.freedesktop.ModemManager1.Modem.Messaging — The ModemManager Messaging interface.

## Methods

    List              (OUT ao    result);
    SetDefaultStorage (IN  u     storage);
    Delete            (IN  o     path);
    Create            (IN  a{sv} properties,
                       OUT o     path);

## Signals

    Added   (o path,
             b received);
    Deleted (o path);

## Properties

    Messages           readable   ao
    SupportedStorages  readable   au
    DefaultStorage     readable   u

## Description

The Messaging interface handles sending SMS messages and notification of new incoming messages.

This interface will only be available once the modem is ready to be registered in the cellular network. 3GPP devices will require a valid unlocked SIM card before any of the features in the interface can be used (including listing stored messages).

## Method Details

### The `List()` method

    List (OUT ao result);

Retrieve all SMS messages.

This method should only be used once and subsequent information retrieved either by listening for the "Added" signal, or by querying the specific SMS object of interest.

Since: 1.0

`OUT ao `result``: | The list of SMS object paths.

### The `SetDefaultStorage()` method

    SetDefaultStorage (IN  u storage);

`IN u `storage``: |

### The `Delete()` method

    Delete (IN  o path);

Delete an SMS message.

Since: 1.0

`IN o `path``: | The object path of the SMS to delete.

### The `Create()` method

    Create (IN  a{sv} properties,
            OUT o     path);

Creates a new message object.

The 'Number' and either 'Text' or 'Data' properties are mandatory, others are optional.

If the SMSC is not specified and one is required, the default SMSC is used.

Since: 1.0

`IN a{sv} `properties``: | Message properties from the SMS D-Bus interface.
`OUT o `path``: | The object path of the new message object.

## Signal Details

### The "Added" signal

    Added (o path,
           b received);

Emitted when any part of a new SMS has been received or added (but not for subsequent parts, if any). For messages received from the network, not all parts may have been received and the message may not be complete.

Check the 'State' property to determine if the message is complete.

Since: 1.0

`o `path``: | Object path of the new SMS.
`b `received``: | `TRUE` if the message was received from the network, as opposed to being added locally.

### The "Deleted" signal

    Deleted (o path);

Emitted when a message has been deleted.

Since: 1.0

`o `path``: | Object path of the now deleted SMS.

## Property Details

### The "Messages" property

    Messages  readable   ao

The list of SMS object paths.

Since: 1.2

### The "SupportedStorages" property

    SupportedStorages  readable   au

A list of MMSmsStorage values, specifying the storages supported by this modem for storing and receiving SMS.

Since: 1.0

### The "DefaultStorage" property

    DefaultStorage  readable   u

A MMSmsStorage value, specifying the storage to be used when receiving or storing SMS.

Since: 1.0